=== clt/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
# CLT - Command Line Tools meta cmake file
##################################################

ADD_SUBDIRECTORY(faltest)
ADD_SUBDIRECTORY(faldisass)
ADD_SUBDIRECTORY(falrun)
ADD_SUBDIRECTORY(falcon)
ADD_SUBDIRECTORY(falpack)
