=== tests/CMakeLists.txt ===
add_subdirectory(testsuite)
