=== debian/changelog ===
falconpl (0.9.6.6-0ubuntu1) natty; urgency=low

  * New upstream release (LP: #620204).
  * Now uses cmake to build the sources.
  * Add new binaries:
    - falpack: A packaging tool to copy all the modules and other dependencies
      needed for a standalone application to run into a target directory.
    - fallc.fal: Language table compiler to compile .ftt files (Falcon
      translation tables) into binary .ftr files (Falcon translation).
  * Bump Standards.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Sun, 17 Oct 2010 13:37:42 +0200
