=== debian/control ===
Source: falconpl
Section: interpreters
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Giancarlo Niccolai <gc@falconpl.org>
Standards-Version: 3.9.1
Build-Depends: cmake (>= 2.0),
 debhelper (>= 7.0.50~),
 bison (>= 1.8),
 zlib1g-dev,
 libpcre3-dev (>= 7.0)
Homepage: http://www.falconpl.org

Package: libfalcon-engine1
Architecture: any
Section: libs
Suggests: falconpl (= ${binary:Version})
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Falcon Programming Language engine
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 Falcon aims to be the next generation scripting language,
 providing a wide set of programming paradigms, template file
 processing for web development and document based applications,
 radical internationalization and application extension support.
 It is distributed under the Falcon Programming Language License,
 an open source license which grants usability of the language
 in any kind of application, including commercial ones.
 .
 This is the main engine of the language, including the engine,
 the Runtime Library and the essential modules.

Package: libfalcon-engine1-dbg
Architecture: any
Priority: extra
Section: debug
Suggests: libfalcon-engine1-dev (= ${binary:Version})
Depends: libfalcon-engine1 (= ${binary:Version}), ${misc:Depends}
Description: The Falcon P.L. engine - debugging symbols
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 Falcon aims to be the next generation scripting language,
 providing a wide set of programming paradigms, template file
 processing for web development and document based applications,
 radical internationalization and application extension support.
 It is distributed under the Falcon Programming Language License,
 an open source license which grants usability of the language
 in any kind of application, including commercial ones.
 .
 This package contains the debugging symbols for libfalcon-engine1
 package.

Package: falconpl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libfalcon-engine1 (= ${binary:Version})
Description: The Falcon P. L. - command line tools
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 This is the set of command line tools that can be used to run
 stand-alone scripts and applications.

Package: falconpl-dbg
Architecture: any
Priority: extra
Section: debug
Suggests: falconpl-dev (= ${binary:Version})
Depends: ${shlibs:Depends}, ${misc:Depends},
         falconpl (= ${binary:Version})
Description: The Falcon P. L. - debugging symbols
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 This package contains the debugging symbols for the falconpl
 package.

Package: falconpl-dev
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, ${misc:Depends},
         falconpl (= ${binary:Version})
Description: The Falcon PL - development files
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 These are the files needed to develop new Falcon modules or
 to embed the Falcon Programming Language in other applications.
