=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -S cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DFALCON_INC_DIR=include \
		-DFALCON_SHARE_DIR=share/falconpl \
		-DFALCON_WITH_FEATHERS="feathers"

override_dh_auto_clean:
	rm -rf devel/release devel/settings*
	dh_auto_clean

override_dh_install:
	dh_install -plibfalcon-engine1 --sourcedir=debian/tmp
	dh_install -pfalconpl --sourcedir=debian/tmp
	dh_install -pfalconpl-dev --sourcedir=debian/tmp

override_dh_strip:
	dh_strip -plibfalcon-engine1 --dbg-package=libfalcon-engine1-dbg
	dh_strip -pfalconpl --dbg-package=falconpl-dbg
	dh_strip -pfalconpl-dev

override_dh_makeshlibs:
	dh_makeshlibs -plibfalcon-engine1 -V
