=== debian/watch ===
version=3
http://www.falconpl.org/project_dl/_official_rel/Falcon-([\d\.]+)\.tar\.gz
